/*
** Copyright (C) 2004 sebastien Gracia <wireless@sgdn.pm.gouv.fr>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
** Copyright disclaimers:
** The Directeur Central de la scurit des systmes d'information hereby
** disclaims all copyright interest in the changes and enhancements
** made by sebastien Gracia.
** 5th Fev 2004.  
*/


#ifndef __SPP_AUTH_FLOOD_H__
#define __SPP_AUTH_FLOOD_H__


/*  I N C L U D E S
*******************************************************************************/
#include "snort.h"


/*  D E F I N E S
*******************************************************************************/

#define AUTH_OPT_threshold "auth-threshold"
#define AUTH_OPT_EXPIRE_TIMEOUT "expire_timeout"
#define AUTH_OPT_TARGET_LIMIT "target_limit"
#define AUTH_OPT_PRUNE_PERIOD "prune_period"


#define AUTH_FLOOD_THRESHOLD 100
#define AUTH_FLOOD_EXPIRE_TIMEOUT 60
#define AUTH_FLOOD_TARGET_LIMIT 10
#define AUTH_FLOOD_PRUNE_PERIOD 30

typedef struct _AuthFloodData
{
  ubi_trRoot AuthAPs;
  ubi_trRootPtr AuthAPsPtr;

  MemPool AuthAPPool;

  u_int16_t offset_alert_flag;
  u_int16_t offset_nbr;
  u_int16_t offset_time;

  u_int32_t auth_threshold;
  u_int32_t expire_timeout;
  u_int32_t target_limit;
  u_int32_t prune_period;

  struct timeval prune_time;

  /** Global Program Data **/
  FILE *logfile;
} AuthFloodData;

/* this represent the authenticated station */
typedef struct _AuthAP
{
  ubi_trNode Node;               /* for the splay tree */
  MemBucket *bucket;

  u_int32_t wst_addr;
  u_int8_t addr[6];
} AuthAP;


/*  P R O T O T Y P E S
*******************************************************************************/

void SetupAuthFlood();
void AuthFloodInit(u_char *);
void AuthFloodParseArgs(char *);
void AuthFloodDetect(Packet *);
int authAPCompareFunc(ubi_trItemPtr, ubi_trNodePtr);
void AddAuthAP(u_int32_t);
u_int32_t PruneAuthAPs(u_int32_t);
void DeleteAuthAP(AuthAP *);
void AuthAPLog(Packet *, u_int32_t);
void AuthFloodRestartFunction(int, void *);
void AuthFloodCleanExitFunction(int, void *);


#endif  /* __SPP_DESFLOOD_H__ */
